# $Id: rss.rb,v 1.2 2003/12/10 16:42:21 not Exp $

=begin

ndiary.conf ł̐ݒ

# RSS
RSS_FILENAME         = 'http://www14.cds.ne.jp/~not/tawagoto/index.rdf'
RSS_CREATER          = 'not(̂Ƃ)'
RSS_TITLE            = 'nonsense talk'
RSS_LINK             = 'http://www14.cds.ne.jp/~not/tawagoto/'
RSS_LINK_BASE        = 'http://www14.cds.ne.jp/~not/tawagoto/'   # L url ̊ƂȂ url
RSS_DESCRIPTION      = '{L nDiaryJ'
RSS_DESCRIPTION_SIZE = 400  # byte. 0 ̏ꍇ <description> o͂Ȃ

# Optional ȗ
RSS_DELETE_HEADCHAR  = true # gsbN̍s폜邩ǂ (true / false)
RSS_DCDATE_TYPE      = 0  # gsbN dc:date ̈
                          # 0: dc:date ͂Ȃ
                          # 1: *.diary ̍XVɂB̃gsbN͑Sē
                          # 2: nDiarys̎ɂ
                          #    OsωȂgsbN͑O̎ێ
                          # 3: *.diary ̍XVɂ
                          #    OsωȂgsbN͑O̎ێ
                          # 3,4 ̏ꍇ LOG_DIRECTORY  rss_cache Ƃt@C쐬܂
RSS_RIGHTS           = 'Copyright ...' # 쌠\
RSS_IMAGE            = 'banner.png' # C[Wt@Cւ URI (oi[)
RSS_CSS              = './rss.xsl' # X^CV[gt@Cւ URI
RSS_CCPL             = '' # CCPL IvV
                          # http://www.alles.or.jp/~spiegel/docs/cc-about.html Q
                          # 'by' , 'by-nd' , 'by-nd-nc' , 'by-nc' , 'by-nc-sa' , 'by-sa' , 'nd' ,
                          # 'nd-nc' , 'nc' , 'nc-sa' , 'sa'

=end

class Filter

  begin
    require 'digest/md5'
  rescue LoadError
    require 'md5'
  end

  def rss(str, type)
    return unless @diary.kind_of?(LastDiary)
    @rss ||= []
    @rss_flag ||= false
    @rss_flag2 ||= false

    case type
    when :TOPIC
      topic = str.gsub(/<\/?([!\w]+)[^>]*>/i, '')
      if @diary.config['RSS_DELETE_HEADCHAR'] != false then
        /^.\s*(.+)$/ =~ topic
        topic = $1
      end
      @rss << [topic, @diary.date, @diary.instance_eval{@cntTopic + 1}, '', '']
      @rss_flag  = true
      @rss_flag2 = true

    when :P, :CODE, :BLOCKQUOTE, :DL, :UL, :QUOTE
      if @rss_flag then
        desc = str.dup
        desc.gsub!(/<\/?([!\w]+)[^>]*>/i, '')
        desc = CGI::escapeHTML(desc)
        desc.gsub!(/[\n\t@]/,'')
        if @diary.config['RSS_DESCRIPTION_SIZE'].nil? then
          desc_size = 400
        else
          desc_size = @diary.config['RSS_DESCRIPTION_SIZE'].to_i
          desc_size = 400 if desc_size < 0
        end
        if desc.size > desc_size
          desc = desc[0..desc_size]
          desc.chop! unless desc.sub!(/.$/,'')
          desc << '...'
        end
        unless desc.empty? then
          @rss[-1][3] = desc
          @rss_flag = nil
        end

        if @rss_flag2 then
          @rss[-1][4] << str
        end

      end

    when :ONEDAY
      @rss_flag  = nil
      @rss_flag2 = nil

    when :HTML
      filename  = @diary.config['RSS_FILENAME'].to_s
      creater   = @diary.config['RSS_CREATER'].to_s
      title     = @diary.config['RSS_TITLE'].to_s
      link      = @diary.config['RSS_LINK'].to_s
      link_base = @diary.config['RSS_LINK_BASE'].to_s
      desc      = @diary.config['RSS_DESCRIPTION'].to_s
      rights    = @diary.config['RSS_RIGHTS'].to_s
      image     = @diary.config['RSS_IMAGE'].to_s
      css       = @diary.config['RSS_CSS'].to_s
      ccpl      = @diary.config['RSS_CCPL'].to_s.downcase

      if filename.empty? then
        $stderr.puts "Filter error: RSS_FILENAME is empty."
        return
      end
      rights = %Q!     <dc:rights>#{rights}</dc:rights>\n! unless rights.empty?
      image_detail = ''
      if not image.empty? then
        image_detail << %Q!  <image rdf:about="#{image}">\n!
        image_detail << %Q!    <title>#{title}</title>\n!
        image_detail << %Q!    <link>#{link}</link>\n!
        image_detail << %Q!    <url>#{image}</url>\n!
        image_detail << %Q!  </image>\n!
        image = %Q!     <image rdf:resource="#{image}"/>\n!
      end
      css = %Q!<?xml-stylesheet href="#{css}" type="text/xsl" media="screen"?>\n! unless css.empty?
      ccpl_detail = ''
      case ccpl
      when 'by'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/by/1.0">
     <cc:requires rdf:resource="http://web.resource.org/cc/Attribution" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
  </cc:License>
CCPL_END
        ccpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      when 'by-nd'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/by-nd/1.0/">
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Attribution" />
  </cc:License>
CCPL_END
        cpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      when 'by-nd-nc'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/by-nd-nc/1.0/">
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Attribution" />
     <cc:prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
  </cc:License>
CCPL_END
        ccpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      when 'by-nc'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/by-nc/1.0/">
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Attribution" />
     <cc:prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
     <cc:permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
  </cc:License>
CCPL_END
        ccpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      when 'by-nc-sa'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/by-nc-sa/1.0/">
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Attribution" />
     <cc:prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
     <cc:permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
     <cc:requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
  </cc:License>
CCPL_END
        ccpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      when 'by-sa'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/by-sa/1.0/">
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Attribution" />
     <cc:permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
     <cc:requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
  </cc:License>
CCPL_END
        ccpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      when 'nd'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/nd/1.0/">
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
  </cc:License>
CCPL_END
        ccpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      when 'nd-nc'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/nd-nc/1.0/">
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
     <cc:prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
  </cc:License>\n!
CCPL_END
        ccpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      when 'nc'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/nc/1.0/">
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
     <cc:prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
     <cc:permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
  </cc:License>
CCPL_END
        ccpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      when 'nc-sa'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/nc-sa/1.0/">
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
     <cc:prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
     <cc:permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
     <cc:requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
  </cc:License>
CCPL_END
        ccpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      when 'sa'
        ccpl_detail = <<CCPL_END
  <cc:License rdf:about="http://creativecommons.org/licenses/sa/1.0/">
     <cc:permits rdf:resource="http://web.resource.org/cc/Reproduction" />
     <cc:permits rdf:resource="http://web.resource.org/cc/Distribution" />
     <cc:requires rdf:resource="http://web.resource.org/cc/Notice" />
     <cc:permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
     <cc:requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
  </cc:License>
CCPL_END
        ccpl = %Q!     <cc:license rdf:resource="http://creativecommons.org/licenses/#{ccpl}/1.0" />\n!
      else
        ccpl = ''
      end
      index = ''
      items = ''
      rss_cache = {}
      begin
        open(@diary.logDirectory + 'rss_cache'){ |f|
          f.each{ |line|
            topic, dcdate, md5 = line.chomp.split(/\t/,3)
            rss_cache[topic] = [dcdate, md5]
          }
        }
      rescue
        rss_cache = {}
      end

      @rss.each{ |t, date, tn, d, str|
        l = @diary.date2monthlyfilelink(date, true) + "_t#{tn}"
        dcdate = ''
        case @diary.config['RSS_DCDATE_TYPE'].to_i
        when 1, 3
          dcdate = File::mtime(@diary.allDiaries[date]).strftime('%Y-%m-%dT%H:%M:%S+09:00')
        when 2
          dcdate = @diary.instance_eval{@now}.strftime('%Y-%m-%dT%H:%M:%S+09:00')
        end
        if @diary.config['RSS_DCDATE_TYPE'].to_i >= 2 then
          key = sprintf("%s_t%03d", date, tn)
          md5 = Digest::MD5::new(str.strip).hexdigest rescue md5 = MD5::new(str.strip).hexdigest
          if rss_cache.key?(key) and rss_cache[key][1] == md5 then
            dcdate = rss_cache[key][0]
          end
          rss_cache[key] = [dcdate, md5]
        end

        index << %Q!        <rdf:li rdf:resource="#{link_base+l}" />\n!
        items << %Q!  <item rdf:about="#{link_base+l}">\n!
        items << %Q!    <title>#{t}</title>\n!
        items << %Q!    <link>#{link_base+l}</link>\n!
        items << %Q!    <description>#{d}</description>\n! unless d.empty?
        items << %Q!    <dc:date>#{dcdate}</dc:date>! unless dcdate.empty?
        items << %Q!  </item>\n!

      }

      unless rss_cache.keys.empty? then
        open(@diary.logDirectory + 'rss_cache', 'w'){ |f|
          rss_cache.keys.sort.reverse[0..50].each{ |t| # 50 ۑƂgsbN̐
            f.puts [t, rss_cache[t][0], rss_cache[t][1]].join("\t")
          }
        }
      end
      
      rss = <<RSS_END
#{css}<rdf:RDF
  xmlns="http://purl.org/rss/1.0/"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
  xmlns:cc="http://web.resource.org/cc/"
  xml:lang="ja">

  <channel rdf:about="#{filename}">
     <dc:language>ja</dc:language>
     <title>#{title}</title>
     <dc:creator>#{creater}</dc:creator>
#{rights}#{ccpl}#{image}     <link>#{link}</link>
     <description>#{desc}</description>
     <sy:updatePeriod>daily</sy:updatePeriod>
     <sy:updateBase>#{@diary.instance_eval{@now}.strftime('%Y-%m-%dT%H:%M:%S+09:00')}</sy:updateBase>
     <items>
       <rdf:Seq>
#{index}       </rdf:Seq>
     </items>
  </channel>
#{items}#{image_detail}#{ccpl_detail}</rdf:RDF>
RSS_END

      rss_filename = @diary.outputDirectory + File::basename(filename)
      open(rss_filename, 'w'){ |f|
        begin
          rss = rss.toutf8
          f.puts '<?xml version="1.0" encoding="UTF-8"?>'
          f.print rss
        rescue 
          f.puts '<?xml version="1.0" encoding="EUC_JP"?>'
          f.print rss.toeuc
        end
      }
    end
  end
end
