# $Id: dateformat.rb,v 1.2 2003/08/21 12:38:37 not Exp $

# Time#strftime g (SJIS Only)

class Time
  def strftime2(format_str)
    return format_str if format_str.empty?

    youbi = %w(      y)

    format = format_str.dup
    format.gsub!(/%e/, youbi[self.wday])
    format.gsub!(/%E/, youbi[self.wday] + 'j')
    format.gsub!(/%d/, self.day.to_s)
    format.gsub!(/%m/, self.month.to_s)
    format.gsub!(/%H/, self.hour.to_s)
    format.gsub!(/%I/, (self.hour % 12).to_s)
    format.gsub!(/%M/, self.min.to_s)
    format.gsub!(/%S/, self.sec.to_s)
    format.gsub!(/%P/, self.hour < 12 ? 'ߑO' : 'ߌ')
    format.gsub!(/%0([dmHIMS])/, '%\\1')

    strftime(format)
  end
end

