# $Id: monthindex.rb,v 1.10 2003/10/07 22:26:41 not Exp $

=begin

  monthindex.rb

    nDiary Plug-in  ʃt@C̃CfbNX쐬

    ʂ̃t@Cւ̃ÑCfbNX쐬܂B

    option:
      month=en        p\Lɂ܂B

      title=str       CfbNXɕt^Cgw肵܂B

      style=simple    <table> g킸ɃCfbNX쐬܂B
      style=table     <table> găCfbNX쐬܂B
      style=flatlist  <ul><li> găCfbNX쐬܂B(1s)
      style=dropdown  <form><select> găCfbNX쐬܂B(vJavaScript)
      
      boder=n         style=table  berder  TCYw肵܂B
      cellspacing=n   style=table  cellspacing  TCYw肵܂B

      dst=filename    o͂ t@Cfilename ɐ؂肩܂

      exsample:
        <!--plug=monthindex?title=ߋ̓L?month=en?style=simple-->

=end


def plug(opt)

  case opt['month']
  when 'en'
    monthname =  %w(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec)
  else
    monthname =  %w(01 02 03 04 05 06 07 08 09 10 11 12)
  end

  opt['border'] = 1 if opt['border'] !~ /^\d+$/
  opt['cellspacing'] = 0 if opt['cellspacing'] !~ /^\d+$/

  firstYear = @months[0][0..3]
  lastYear = @months[@months.size - 1][0..3]

  monthlist = {}
  
  for year in firstYear..lastYear
    for month in "01".."12"
      href = date2monthlyfilelink(year + month)
      if href.empty? and File::readable?(@outputDirectory + year + month + '.html') then
        href = '../' * @filename.scan(%r"[^/]+/").size + @monthlyFilename.gsub(/%Y/, year).gsub(/%0m/, month).gsub(%r"^\./", '')
      end
      monthlist[year] = [] unless monthlist.key?(year)
      monthlist[year] << href
    end
  end

  html = t1 = t2 = t3 = t4 = t5 = t6 = ''

  case opt['style']
  when 'dropdown'
    t1 = %Q!<form action="./"><select tabindex="0" onchange="location.href=this.options[this.selectedIndex].value"><optgroup label="Month"><option value="">Select</option></optgroup>!
    t2 = '%Q!<optgroup label="#{year}">!'
    t3 = '%Q!<option value="#{monthlist[year][month]}">#{year}-#{monthname[month]}</option>!'
    t4 = '""'
    t5 = "</optgroup>"
    t6 = "</select></form>"
  when 'simple'
    t1 = "\n<ul class=\"monthindex\">\n"
    t2 = '%Q!\t<li><strong class="monthindex">#{year}</strong> [ !'
    t3 = '%Q!<a href="#{monthlist[year][month]}">#{monthname[month]}</a>, !'
    t4 = '%Q!#{monthname[month]}, !'
    t5 = " ]</li>\n"
    t6 = "</ul>"
  when 'flatlist'
    t1 = "\n<ul class=\"monthindex\">\n"
    t2 = '""'
    t3 = '%Q!<li><a href="#{monthlist[year][month]}">#{year}-#{monthname[month]}</a></li>\n!'
    t4 = '""'
    t5 = ""
    t6 = "</ul>"
  when 'table'
    t1 = %Q!<table border="#{opt['border']}" cellspacing="#{opt['cellspacing']}">\n!
    if opt['title']
      t1 << '<tr><th colspan="13">' << opt['title'] << "</th></tr>\n"
    end
    t2 = '%Q!\t<tr>\n\t\t<th>#{year}</th>\n!'
    t3 = '%Q!\t\t<td><a href="#{monthlist[year][month]}">#{monthname[month]}</a></td>\n!'
    t4 = '%Q!\t\t<td>#{monthname[month]}</td>\n!'
    t5 = "\t</tr>\n\n"
    t6 = "</table>\n\n"
  end

  html = t1
  for year in firstYear..lastYear
    html << eval(t2)
    for month in 0..11
      unless monthlist[year][month].to_s.empty?
        html << eval(t3)
      else
        html << eval(t4)
      end
    end
    html.chop!.chop! if opt['style'] == 'simple'
    html << t5
  end
  html << t6

  if opt['dst'] and (not opt['dst'].empty?) then
    if /^([a-zA-Z]:)?\// !~ opt['dst'] then
#      opt['dst'] = File::expand_path(opt['dst'], @outputDirectory)
      opt['dst'] = @outputDirectory + opt['dst']
    end
    begin
      outfile = open(opt['dst'], "w")
      outfile.print html
      outfile.close
      html = "<!--monthindex-->"
    rescue Errno::ENOENT
      $stderr.print "Plug-in error: monthindex > dst file not found!\n"
      html = "<!--plug-in error: monthindex-->"
    end
  end

  return html

end
