# $Id: schedule.rb,v 1.2 2003/08/21 12:38:37 not Exp $

=begin

  schedule.rb

    nDiary Plug-in  XPW[̕\

    ̃XPW[\܂B


    option:
      format=str    str ͔Cӂ̕Bȉ͓̕WJ܂B

        %A    j̖(Sunday, Monday...) 
        %a    j̏ȗ(Sun, Mon...) 
        %B    ̖(January, February...) 
        %b    ̏ȗ(Jan, Feb...) 
        %c    tƎ 
        %d    (01-31) 
        %j    N̒ʎZ(001-366) 
        %m    \(01-12) 
        %U    T\Dŏ̓j1T̎n܂(00-53) 
        %W    T\Dŏ̌j1T̎n܂(00-53) 
        %w    j\Dj0(0-6) 
        %x    t 
        %Y    \ 
        %y    ̉2(00-99) 
        %%    %g 

        title=str   XPW[ɕt^Cgw肵܂B
        max=num     \ős
        past=num    numǑo߂Ă܂t̏񂩂\܂

   exsample:
     <!--plug=schedule?file=c:/home/www/cds/tawagoto/log/schedule.txt-->


=end


def plug(opt)

  max = 8 if opt['max'].to_i == 0

  today  = Time::now
  past   = today - opt['past'].to_i * 86400
  coming = today + 30 * 86400

  start = past.strftime("%Y%m%d")
  last  = coming.strftime("%Y%m%d")

  schedule = {}

  opt['format'] = opt['format'] ? opt['format'] : '%0m/%0d'

  begin
    open(opt['file'], 'r'){ |file|
      file.each{ |line|
        date, value = line.split(/\t/)
        date.gsub!(/[-\/]/, '')
        if start <= date and date <= last then
          schedule[date] = [] unless schedule[date]
          schedule[date] << value
        end
      }
    }
  rescue Errno::ENOENT
    return '<!--plug-in error: schedule   file not found-->'
  end

  max = opt['max'].to_i
  max = 8 if max == 0

  cnt = 0
  str = ''
  str << %Q!<ul class="schedule">\n!
  schedule.sort.each{ |date, schedules|
    break if cnt >= max
    t = nil
    t = Time::local(date[0..3].to_i, date[4..5].to_i, date[6..7].to_i)
    day = t.strftime2(opt['format'])
    if cnt <= max then
      schedules.sort.each{ |line|
        cnt += 1
        str << %Q!\t<li><strong class="schedule">#{day}</strong> : #{line}</li>\n!
      }
    end
  }
  str << "</ul>\n"

  if opt['title'] then
    str = %Q!<dl>\n<dt class="schedule">#{opt['title']}</dt>\n<dd>#{str}</dd>\n</dl>!
  end

  return str
end
