# $Id: bookstore.rb,v 1.12 2003/08/21 12:38:37 not Exp $

=begin

    (ISBN4-04-873259-5) ƂƂƊeICXւ̃Nɕϊ

    ndiary.conf Ɉȉ̂悤ȍsǉƕ\ICXƂ̏Ԃ
    wł܂B

    BOOKSTORE_SHOP_LIST = 'amazon bk1 yahoo asahiya jbook kinokuniya rakuten skysoft'

    wł͈̂ȉ̃ICXłB

    bk1          bk1 <http://www.bk1.co.jp/>
    amazon       amazon.co.jp <http://www.amazon.co.jp/>
    yahoo        Yahoo! Books <http://books.yahoo.co.jp/>
    asahiya      X <http://www.netdirect.co.jp/>
    jbook        Jbook <http://www.jbook.co.jp/>
    kinokuniya   IɚX <http://bookweb.kinokuniya.co.jp/>
    rakuten      yVubNX <http://books.rakuten.co.jp/RBOOKS/index.html>
    skysoft      skysoft <http://www.skysoft.co.jp/>

    ܂Am̏ꍇ͓lɈȉ̂悤Ɏw肵ĂB

    # ISBN0-xxx
    BOOKSTORE_SHOP_LIST_0 = 'amazon amazon.com skysoft a1books powells kinokuniya maruzen'

    skysoft      skysoft <http://www.skysoft.co.jp/>
    amazon       amazon.co.jp <http://www.amazon.co.jp/>
    amazon.com   amazon.com <http://www.amazon.com/>
    a1books      a1books <http://www.a1books.com/>
    powells      powells.com <http://www.powells.com/home.html>
    kinokuniya   IɚX <http://bookweb.kinokuniya.co.jp/>
    maruzen      ۑP <http://www.maruzen.co.jp/>

    # ISBN1-xxx
    BOOKSTORE_SHOP_LIST_1 = 'amazon bookshop'

    amazon       amazon.co.uk <http://www.amazon.co.uk>
    bookshop     The Internet Bookshop <http://www.bookshop.co.uk>


    A\VGCgEvOɎQĂꍇ ndiary.conf Ɉȉ̍sǉ
    񎩕 ID ɒāB
    
    # bk1 
    BOOKSTORE_BK1_ID = 'p-not00114'

    # amazon.co.jp
    BOOKSTORE_AMAZON_ID = 'notsfragmen-22'

    # yV
    BOOKSTORE_RAKUTEN_ID = '0001fc8b.1fe901a6'
    
    (http://homepage3.nifty.com/akima/)̃ICXւ̃N
    Qlɍ쐬܂B
    
=end

class Filter

  BOOKSTORE = Regexp::compile(/[\(i]ISBN(\d-[\d-]{9}-\w)[\)j]/)

  def bookstore(str, type)

    if @diary.respond_to?('config') then
      bk1_id     = @diary.config['BOOKSTORE_BK1_ID'].to_s
      amazon_id  = @diary.config['BOOKSTORE_AMAZON_ID'].to_s
      rakuten_id = @diary.config['BOOKSTORE_RAKUTEN_ID'].to_s

      bk1_id = 'aid=' + bk1_id + '&amp;' unless bk1_id.empty?
      rakuten_id = 'http://pt.afl.rakuten.co.jp/c/' + rakuten_id + '/?url=' unless rakuten_id.empty?

      shop_list   = @diary.config['BOOKSTORE_SHOP_LIST'].to_s
      shop_list0  = @diary.config['BOOKSTORE_SHOP_LIST_0'].to_s
      shop_list1  = @diary.config['BOOKSTORE_SHOP_LIST_1'].to_s
    else
      bk1_id = ''
      amazon_id = ''
    end

    if shop_list.empty? then
      shop_list = 'bk1 amazon yahoo asahiya jbook kinokuniya rakuten skysoft'
    end

    if shop_list0.empty? then
      shop_list0 = 'amazon amazon.com skysoft a1books powells kinokuniya maruzen'
    end

    if shop_list1.empty? then
      shop_list1 = 'amazon bookshop'
    end

    shop_link = {}

    case type
    when :P, :UL, :DL
      str.gsub!(BOOKSTORE){
        isbn  = $1
        isbn2 = isbn.delete('-')
        if isbn2 =~ /^4/ then
          shop_link['bk1'] = '<a href="http://www.bk1.co.jp/cgi-bin/srch/srch_result_book.cgi?' + bk1_id + 'idx=3&amp;isbn=' + isbn + '">bk1</a>'
          shop_link['amazon'] = '<a href="http://www.amazon.co.jp/exec/obidos/ASIN/' + isbn2 + '/' + amazon_id + '/ref=nosim">amazon</a>'
          shop_link['yahoo'] = '<a href="http://books.yahoo.co.jp/bin/search_key?pp=3&p=' + isbn + '">Yahoo!</a>'
          shop_link['asahiya'] = '<a href="http://www.netdirect.co.jp/search/ISSSchDetail.asp?ISBN=' + isbn2 + '"></a>'
          shop_link['jbook'] = '<a href="http://www.jbook.co.jp/product.asp?isbn=' + isbn2 + '">Jbook</a>'
          shop_link['kinokuniya'] = '<a href="http://bookweb.kinokuniya.co.jp/guest/cgi-bin/wshosea.cgi?W-ISBN=' + isbn2 + '">Iɚ</a>'
          shop_link['rakuten'] = '<a href="' + rakuten_id + 'http://books.rakuten.co.jp/bsearch/RBtitles.jsp?KEY=' + isbn + '">yV</a>'
          shop_link['skysoft'] = '<a href="http://www.skysoft.co.jp/GetTitleDetail.asp?ISBN=' + isbn + '">skysoft</a>'

          'y ' + shop_list.split(/\s+/).collect!{ |shop| shop_link[shop].to_s }.join(' / ') + ' z'

        elsif isbn2 =~ /^0/
          shop_link['skysoft'] = '<a href="http://www.skysoft.co.jp/GetTitleDetail.asp?C=2&ISBN=' + isbn2 + '">skysoft</a>'
          shop_link['amazon'] = '<a href="http://www.amazon.co.jp/exec/obidos/ASIN/' + isbn2 + '/' + amazon_id + '">amazon</a>'
          shop_link['amazon.com'] = '<a href="http://www.amazon.com/exec/obidos/ASIN/' + isbn2 + '/">amazon.com</a>'
          shop_link['a1books'] = '<a href="http://www.a1books.com/cgi-bin/a1Search?searchBy=isbn&searchStr=' + isbn2 + '">A1Books</a>'
          shop_link['powwlls'] = '<a href="http://www.powells.com/search/DTSearch/search?isbn=' + isbn2 + '">Powells.com</a>'
          shop_link['kinokuniya'] = '<a href="http://bookweb.kinokuniya.co.jp/guest/cgi-bin/booksea.cgi?ISBN=' + isbn2 + '">Iɚ</a>'
          shop_link['maruzen'] = '<a href="http://www.maruzen.co.jp/cgi-bin/cgirelay/mis-ir-y1?isbn-1=' + isbn2 + '">ۑP</a>'

          'y ' + shop_list0.split(/\s+/).collect!{ |shop| shop_link[shop].to_s }.join(' / ') + ' z'

        elsif isbn2~ /^1/
          shop_link['amazon'] = '<a href="http://www.amazon.co.uk/exec/obidos/ASIN/' + isbn2 + '/">amazon.co.uk</a>'
          shop_link['bookshop'] = '<a href="http://www.bookshop.co.uk/ser/serpge.asp?I=' + isbn2 + '/">The Internet Bookshop</a>'

          'y ' + shop_list1.split(/\s+/).collect!{ |shop| shop_link[shop].to_s }.join(' / ') + ' z'
        end

      }
    end

  end
  
end
