#$Id: footnote.rb,v 1.2 2003/08/21 12:38:37 not Exp $

=begin

    r쐬܂BnDiary ver 0.9.2 ܂őgݍ݋@\̂tB^̂łB

    ŕuقق(*r)vƋLqꍇ́u(*vƁu)vň͂܂ꂽA
    uقق((-r-))vƋLqꍇ́u((-vƁu-))vň͂܂ꂽA
    ̓̍Ō̕ɎIɑ}܂B

    ndiary.conf Ɉȉ̋LqǉƋr̃NgAtitleɂ̓eݒ肵܂B

    FOOTNOTE_EXPAND = true

    
=end

class Filter

  def footnote(str, type)

    case type
    when :ONEDAY
      @filter_footnotes = []

    when :P, :BLOCKQUOTE, :DL, :UL
      str.gsub!(/\([\*]([^\)]+)\)|i[\*]([^j]+)j|\(\(-(.+?)-\)\)/){
        @filter_footnotes << $+
        name = "#{@diary.date}_#{@filter_footnotes.size}"
        if @diary.config['FOOTNOTE_EXPAND'] then
          tip = $+.gsub(/<a [^>]*href="(.+?)".*?>(.+?)<\/a>/im){
            $1 == $2 ? $1 : "#$2(#$1)"
          }.gsub(/<\/?([!\w]+)[^>]*>/im, '')
          tip = tip[0..200] + '...' if tip.size > 200
          title = %! title="#{tip}" !
        else
          title = ''
        end
        %Q!<sup><small>(<a href="#f#{name}" #{title}#{@diary.isXHTML ? 'id' : 'name'}="b#{name}">*#{@filter_footnotes.size}</a>)</small></sup>!
      }
      str.gsub!(/\(\\\*/,"\(\*")

    when :AFTER_ONEDAY
      unless @filter_footnotes.empty? then
        cnt = 0
        footnote = %Q!\t<div class="footnote">\n!
        @filter_footnotes.each{ |s|
          cnt += 1
          name = "#{@diary.date}_#{cnt}"
          footnote << %Q!\t\t<a #{@diary.isXHTML ? 'id' : 'name'}="f#{name}" !
          footnote << %Q!href="#b#{name}">\*#{cnt}</a>: #{s}#{@diary.tag_br}\n!
        }
        footnote << "\t</div>\n"
        
        str.sub!(%r"</div>[\r\n]+\Z", "#{footnote}</div>\n\n")
      end
    end
  end

end
