# $Id: inlinedecorate.rb,v 1.9 2003/10/30 16:40:59 not Exp $

=begin

  usage:

    {̈ȉ̕^Ot̕ɕϊ

    **foo**      ->   <strong>foo</strong>
    ***foo***    ->   <strong class="laud">foo</strong>
    --foo--      ->   <strike>foo</strike>

    SpXy[XŎn܂āÁstJbRɓǂ݂LĂ
    @fooshoget -> <ruby><rb>foo</rb><rp>(</rp><rt>hoge</rt><rp>)</rp></ruby>
  
    SpXy[XŎn܂āÃJbR uri LẮB
    @foo(http://hoge.com/)  ->  <a href="http://hoge.com/">foo</a>

    SpXy[XŎn܂āÃJbR diary: LĂāǍ
    tAgsbNԍAi̔ԍẮB
    @ߋL(diary:2001/01/01,t1,2) -> <a href="200101.html#01_t1_2">ߋL</a>
    

   *݂(http://www.nekomimist.org/)A
    Ȃ肳(http://woinary.pobox.ne.jp//)̃R[hQlɍ쐬܂B

=end

class Filter
  def inlinedecorate(str, type)

    case type
    when :TOPIC, :P, :UL, :DL
      str.gsub!(/\*\*\*(.+?)\*\*\*/m, '<strong class="laud">\1</strong>')
      str.gsub!(/\*\*(.+?)\*\*/m, '<strong>\1</strong>')
      str.gsub!(/([^!]|^)--([^>]+?)--/m, @diary.isXHTML ? '\1<del>\2</del>' : '\1<strike>\2</strike>')
      str.gsub!(/@([^@]+)s(.+?)t/m, '<ruby><rb>\1</rb><rp>(</rp><rt>\2</rt><rp>)</rp></ruby>')
        
      # Link
      str.gsub!(/@([^@]+)\(((?:https?:|ftp:|mailto:|news:)[^)]+)\)/, '<a href="\2">\1</a>')
      str.gsub!(/@([^@]+)\(diary:(\d\d\d\d)[,\.\/\-_](\d\d?)[,\.\/\-_](\d\d?)(.*?)\)/){
        text = $1
        y = $2.to_i
        m = $3.to_i
        d = $4.to_i
        etc = $5.to_s
        link = @diary.date2monthlyfilelink(format('%04d%02d%02d',y,m,d), true)
        link << "_t#{$1.to_i}" if /[,\.\/\-_]t(\d+)/ =~ etc
        link << "_#{$1.to_i}"  if /[,\.\/\-_](\d+)/ =~ etc
        %Q!<a href="#{link}">#{text}</a>!
      }
      str.gsub!(/@([^@]+)\((\.[^)]+)\)/){
        text = $1
        link = $2
        link = '../' * @diary.filename.scan(%r"[^/]+/").size + link.gsub(%r"^\./", '')
        %Q!<a href="#{link}">#{text}</a>!
      }
    end

  end
end
