;;; -*- Mode: Lisp; Package: EDITOR -*-
;;;
;;; This file is part of xyzzy.
;;;
;
;
;    
;    .xyzzy ňȉݒ肵ĂB

;    (load-library "ndiary-mode")
;    (push '("\\.diary$" . ndiary-mode) *auto-mode-alist*)
;
;    ; ndiary.conf  LOG_DIRECTORY Őݒ肵fBNg
;    (setq *ndiary-directory* "c:/home/www/cds/tawagoto/log")
;
;    ݒ肵܂ł͑OƂēLNe
;    (setq *ndiary-yesterday-hour* 8)
;
;    ndiary ̃XNvg̃pXBndiary-win32 gꍇ ndiary.exe ̃tpXB
;    (setq *ndiary-filename* "C:/home/www/cds/dev/ndiary/script/diary")
;
;    Abv[hp̃vÕpX
;    (setq *ndiary-upload-command* "C:/tools/internet/ffftp/ffftp.exe")
;
;    vr[ html ̃pX
;    (setq *ndiary-html* "C:/home/www/cds/tawagoto/index.html")
;
;    ndiarysɂɎIɕۑ邩ǂ ( t / nil )
;    (setq *ndiary-offer-save* t)
;
;
;    M-x ndiary-edit  ndiary-mode N܂B
;
;    L[oCh̓ftHgňȉ̂悤ɂȂĂ܂
;
;    C-c C-c      ndiary sBIvVw肷Ƃ̓~jobt@
;                 R}hC𒼐ڕҏWĂB
;    C-c C-u      ݒ肵Abv[hpvON
;    C-c C-e      [W < , > , &  &lt; , &gt; , &amp; ɕϊ
;    C-c C-d      [W &lt; , &gt; , &amp;  < , > , & ɕϊ
;    F9           xyzzy ̃EBhEɍ쐬ꂽ html \ (vbrowser.dll)
;    S-F9         ֘AÂꂽuEUō쐬ꂽ html \
;
;    


(provide "ndiary-mode")

(in-package "editor")

;; ݒ
(defvar *ndiary-directory* "~/diary")
(defvar *ndiary-yesterday-hour* 0)
(defvar *ndiary-filename* "diary")
(defvar *ndiary-html* nil)
(defvar *ndiary-upload-command* nil)
(defvar *ndiary-offer-save* nil)

(export '(*ndiary-mode-hook*
		  *ndiary-mode-map*
		  *ndiary-directory*
		  *ndiary-yesterday-hour*
		  *ndiary-filename*
		  *ndiary-html*
		  *ndiary-topic-char*
		  *ndiary-offer-save*
		  *ndiary-upload-command*
		  ndiary-mode
		  ndiary-edit
		  ndiary-preview-html
		  ndiary-open-html
		  ndiary-compile
		  ndiary-upload
		  encode-html-char
		  decode-html-char))

(defvar *ndiary-mode-hook* nil)

;; 

; L[蓖
(defvar *ndiary-mode-map* nil)
(unless *ndiary-mode-map*
  (setq *ndiary-mode-map* (make-sparse-keymap))
  (define-key *ndiary-mode-map* #\F9 'ndiary-preview-html)
  (define-key *ndiary-mode-map* #\S-F9 'ndiary-open-html)
  (define-key *ndiary-mode-map* '(#\C-c #\C-c) 'ndiary-compile)
  (define-key *ndiary-mode-map* '(#\C-c #\C-u) 'ndiary-upload)
  (define-key *ndiary-mode-map* '(#\C-c #\C-e) 'encode-html-char)
  (define-key *ndiary-mode-map* '(#\C-c #\C-d) 'decode-html-char))

(defvar *ndiary-mode-abbrev-table* nil)
(unless *ndiary-mode-abbrev-table*
  (define-abbrev-table '*ndiary-mode-abbrev-table*))

;; FtĂ݂
(defvar *ndiary-keyword*
  (compile-regexp-keyword-list
   '(("^[].+$" t 6)
	 ("^E.+$" t 1)
	 ("^	.+$" t 1)
	 ("^Code:.*$" t 1)
	 ("([\\*].+?)" t 2)
	 ("i[\\*].+?j" t 2)
	 ("<[^>]+>" t :tag)
	 ("\\*\\*[^\\*]+?\\*\\*" t (:keyword 2 :bold))
	 ("\\*\\*\\*[^\\*]+?\\*\\*\\*" t (:keyword 2 :bold))
	 ("--.+?--" t (:keyword 0 :strike-out))
	 ("@[^@]+(\\(https?:\\|ftp:\\|mailto:\\|news:\\|diary:\\)[^)]*)" t (:keyword 0 :underline))
	 ("@[^@]+s[^t]*t" t 1)
	)))


(defun ndiary-mode ()
  (interactive)
  (kill-all-local-variables)
  (setq buffer-mode 'ndiary-mode)
  (setq mode-name "nDiary")
  (use-keymap *ndiary-mode-map*)
  (setq html-highlight-mode t)
  (setq *local-abbrev-table* *ndiary-mode-abbrev-table*)

  (make-local-variable 'regexp-keyword-list)
  (setq regexp-keyword-list *ndiary-keyword*)

  (run-hooks '*ndiary-mode-hook*))



;; X
; ̓L̃t@CJ
(defun ndiary-edit()
  "̓̕L"
  (interactive)

  ; t擾
  (setq diarydate (- (get-universal-time) (* *ndiary-yesterday-hour* 3600)))
  (setq yyyy (format-date-string "%Y" diarydate))
  (setq mm   (format-date-string "%m" diarydate))
  (setq dd   (format-date-string "%d" diarydate))

  (setq diarydir (concat (append-trail-slash *ndiary-directory*) yyyy "/" mm "/"))
  (unless (file-exist-p diarydir)
	(create-directory diarydir))
  (setq diaryfile (concat yyyy mm dd ".diary"))

  (find-file (concat diarydir diaryfile)))

; L쐬
(defun ndiary-compile()
  "L html ɕϊ"
  (interactive)
  (if *ndiary-offer-save*
	(save-some-buffers))
  (cd (directory-namestring *ndiary-filename*))
  (if (string-matchp ".exe$" *ndiary-filename*)
      (setq cmd (read-string "Script: " :default *ndiary-filename*))
    (setq cmd (read-string "Script: " :default (concat "ruby " *ndiary-filename*))))
  (pop-to-buffer (get-buffer-create "nDiary output") 8)
  (execute-shell-command cmd nil "nDiary output")
  (other-window -1))

; LT[oɃAbv[h
(defun ndiary-upload()
  (interactive)
  "LT[oɃAbv[h"
  (shell-execute *ndiary-upload-command* t))

; L html ֘AÂꂽuEUŊJ
(defun ndiary-open-html()
  (interactive)
  "LuEUŌ"
  (shell-execute *ndiary-html* t))

; html preview on IE
(require "wip/winapi")
(c:define-dll-entry winapi:BOOL ShowWindow (winapi:HWND c:int) "user32")

(require "browser")
(defvar browser-last-page "")

(defun ndiary-preview-html()
  (interactive)
  "L IE Ńvr["
  (setq filename *ndiary-html*)
  (or (and initialized
		   (string= browser-last-page filename)
		   (ShowWindow (get-window-handle) 9)
		   (close-browser))
	  (and (setq browser-last-page filename)
		   (ShowWindow (get-window-handle) 3)
		   (navigate browser-last-page))))

(defun encode-html-char (from to)
  (interactive "r")
  (save-excursion
    (save-restriction
	  (narrow-to-region from to)
	  (goto-char (point-min))
	  (replace-buffer "&" "&amp;")
	  (goto-char (point-min))
	  (replace-buffer "\"" "&quot;")
	  (goto-char (point-min))
	  (replace-buffer ">" "&gt;")
	  (goto-char (point-min))
	  (replace-buffer "<" "&lt;"))))

(defun decode-html-char (from to)
  (interactive "r")
  (save-excursion
    (save-restriction
	  (narrow-to-region from to)
	  (goto-char (point-min))
	  (replace-buffer "&lt;" "<" )
	  (goto-char (point-min))
	  (replace-buffer "&gt;" ">")
	  (goto-char (point-min))
	  (replace-buffer "&quot;" "\"")
	  (goto-char (point-min))
	  (replace-buffer "&amp;" "&"))))
